Index: trunk/source/processes/electromagnetic/standard/include/G4UniversalFluctuation.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4UniversalFluctuation.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4UniversalFluctuation.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4UniversalFluctuation.hh,v 1.6 2008/10/22 16:04:33 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4UniversalFluctuation.hh,v 1.10 2009/03/19 14:15:17 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -70,21 +70,19 @@
   virtual ~G4UniversalFluctuation();
 
-  G4double SampleFluctuations(const G4Material*,
-                          const G4DynamicParticle*,
- 				G4double&,
-                                G4double&,
-                                G4double&);
+  virtual G4double SampleFluctuations(const G4Material*,
+				      const G4DynamicParticle*,
+				      G4double&,
+				      G4double&,
+				      G4double&);
 
-  G4double Dispersion(    const G4Material*,
-                          const G4DynamicParticle*,
- 				G4double&,
-                                G4double&);
+  virtual G4double Dispersion(    const G4Material*,
+				  const G4DynamicParticle*,
+				  G4double&,
+				  G4double&);
 
-  void InitialiseMe(const G4ParticleDefinition*);
+  virtual void InitialiseMe(const G4ParticleDefinition*);
 
   // Initialisation prestep
-  inline void SetParticleAndCharge(const G4ParticleDefinition*, G4double q2);
-
-protected:
+  virtual void SetParticleAndCharge(const G4ParticleDefinition*, G4double q2);
 
 private:
@@ -113,7 +111,4 @@
   G4double e0;
 
-  G4double facwidth;
-  G4double oldloss;
-  G4double samestep;
   G4double e1,e2;
 
@@ -126,17 +121,4 @@
 };
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline void 
-G4UniversalFluctuation::SetParticleAndCharge(const G4ParticleDefinition* part,
-					     G4double q2)
-{
-  if(part != particle) {
-    particle       = part;
-    particleMass   = part->GetPDGMass();
-  }
-  chargeSquare = q2;
-}
-
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
Index: trunk/source/processes/electromagnetic/standard/include/G4UrbanMscModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4UrbanMscModel.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4UrbanMscModel.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4UrbanMscModel.hh,v 1.33 2008/03/10 10:39:21 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4UrbanMscModel.hh,v 1.35 2009/04/29 13:30:22 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -37,44 +37,10 @@
 // Author:        Laszlo Urban
 //
-// Creation date: 01.03.2001
+// Creation date: 06.03.2008
 //
 // Modifications:
 //
-// 27-03-03 Move model part from G4MultipleScattering (V.Ivanchenko)
-// 27-03-03 Rename (V.Ivanchenko)
-//
-// 05-08-03 angle distribution has been modified (L.Urban)
-// 26-11-03 new data member currentRange (L.Urban)
-// 01-03-04 changes in data members + signature changed in SampleCosineTheta
-// 11-03-04 changes in data members (L.Urban)
-// 23-04-04 changes in data members and in signature of SampleCosineTheta
-//          (L.Urban)
-// 17-08-04 name of data member facxsi changed to factail (L.Urban)
-// 08-04-05 Major optimisation of internal interfaces (V.Ivantchenko)
-// 15-04-05 optimize internal interface - add SampleSecondaries method (V.Ivanchenko)
-// 11-08-05 computation of lateral correlation added (L.Urban)
-// 02-10-05 nuclear size correction computation removed, the correction
-//          included in the (theoretical) tabulated values (L.Urban)
-// 16-02-06 data members b and xsi have been removed (L.Urban)
-// 17-02-06 Save table of transport cross sections not mfp (V.Ivanchenko)
-// 07-03-06 Create G4UrbanMscModel and move there step limit calculation (V.Ivanchenko)
-// 10-05-06 SetMscStepLimitation at initialisation (V.Ivantchenko)
-// 11-05-06 name of data member safety changed to presafety, some new data
-//          members added (frscaling1,frscaling2,tlimitminfix,nstepmax)
-//         (L.Urban)
-// 13-10-06 data member factail removed, data member tkinlimit changed
-//          to lambdalimit,
-//          new data members tgeom,tnow,skin,skindepth,Zeff,geomlimit
-//          G4double GeomLimit(const G4Track& track) changed to
-//              void GeomLimit(const G4Track& track) (L.Urban)
-// 20-10-06 parameter theta0 now computed in the (public)
-//          function ComputeTheta0,
-//          single scattering modified allowing not small
-//          angles as well (L.Urban)
-// 31-01-07 code cleaning (L.Urban)
-// 06-02-07 Move SetMscStepLimitation method into the source (VI)
-// 15-02-07 new data member : smallstep (L.Urban)
-// 10-04-07 remove navigator, smallstep, tnow (V.Ivanchenko)
-//
+// 28-04-09  move G4UrbanMscModel2 from the g49.2 to G4UrbanMscModel. 
+//           now it is frozen (V.Ivanchenk0)
 //
 // Class Description:
@@ -111,5 +77,5 @@
 
   void Initialise(const G4ParticleDefinition*, const G4DataVector&);
-				          
+
   G4double ComputeCrossSectionPerAtom(const G4ParticleDefinition* particle,
 				      G4double KineticEnergy,
@@ -119,10 +85,4 @@
 				      G4double emax=DBL_MAX);
 
-  void SampleSecondaries(std::vector<G4DynamicParticle*>*, 
-			 const G4MaterialCutsCouple*,
-			 const G4DynamicParticle*,
-			 G4double,
-			 G4double);
-
   void SampleScattering(const G4DynamicParticle*,
 			G4double safety);
@@ -141,4 +101,6 @@
 private:
 
+  G4double SimpleScattering(G4double xmeanth, G4double x2meanth);
+
   G4double SampleCosineTheta(G4double trueStepLength, G4double KineticEnergy);
 
@@ -147,9 +109,9 @@
   G4double LatCorrelation();
 
-  void GeomLimit(const G4Track& track);
-
   inline G4double GetLambda(G4double kinEnergy);
 
   inline void SetParticle(const G4ParticleDefinition*);
+
+  inline void UpdateCache();
 
   //  hide assignment operator
@@ -160,5 +122,4 @@
   G4ParticleChangeForMSC*     fParticleChange;
 
-  G4SafetyHelper*             safetyHelper;
   G4PhysicsTable*             theLambdaTable;
   const G4MaterialCutsCouple* couple;
@@ -166,7 +127,6 @@
 
   G4double mass;
-  G4double charge;
-
-  G4double masslimite,masslimitmu;
+  G4double charge,ChargeSquare;
+  G4double masslimite,lambdalimit,fr;
 
   G4double taubig;
@@ -174,10 +134,9 @@
   G4double taulim;
   G4double currentTau;
-  G4double frscaling1,frscaling2;
   G4double tlimit;
   G4double tlimitmin;
   G4double tlimitminfix;
-
-  G4double nstepmax;
+  G4double tgeom;
+
   G4double geombig;
   G4double geommin;
@@ -198,16 +157,25 @@
   G4double currentKinEnergy;
   G4double currentRange; 
+  G4double rangeinit;
   G4double currentRadLength;
 
-  G4double Zeff;
+  G4double theta0max,rellossmax;
+  G4double third;
 
   G4int    currentMaterialIndex;
+
+  G4double y;
+  G4double Zold;
+  G4double Zeff,Z2,Z23,lnZ;
+  G4double coeffth1,coeffth2;
+  G4double coeffc1,coeffc2;
+  G4double scr1ini,scr2ini,scr1,scr2;
 
   G4bool   isInitialized;
   G4bool   inside;
   G4bool   insideskin;
-
 };
 
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
@@ -236,4 +204,5 @@
     mass = p->GetPDGMass();
     charge = p->GetPDGCharge()/eplus;
+    ChargeSquare = charge*charge;
   }
 }
@@ -241,4 +210,20 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
+inline
+void G4UrbanMscModel::UpdateCache()                                   
+{
+    lnZ = std::log(Zeff);
+    coeffth1 = 0.885+lnZ*(0.104-0.0170*lnZ);
+    coeffth2 = 0.028+lnZ*(0.012-0.00125*lnZ);
+    coeffc1  = 2.134-lnZ*(0.1045-0.00602*lnZ);
+    coeffc2  = 0.001126-lnZ*(0.0001089+0.0000247*lnZ);
+    Z2 = Zeff*Zeff;
+    Z23 = std::exp(2.*lnZ/3.);
+    scr1     = scr1ini*Z23;
+    scr2     = scr2ini*Z2*ChargeSquare;
+  //  lastMaterial = couple->GetMaterial();
+    Zold = Zeff;
+}
+
 #endif
 
Index: trunk/source/processes/electromagnetic/standard/include/G4UrbanMscModel2.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4UrbanMscModel2.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4UrbanMscModel2.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4UrbanMscModel2.hh,v 1.11 2008/12/18 13:01:34 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4UrbanMscModel2.hh,v 1.17 2009/05/15 09:26:42 urban Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -40,5 +40,5 @@
 //
 // Modifications:
-//
+// 23.04.2009 L.Urban updated parameterization in UpdateCache method
 //
 //
@@ -84,10 +84,4 @@
 				      G4double emax=DBL_MAX);
 
-  void SampleSecondaries(std::vector<G4DynamicParticle*>*, 
-			 const G4MaterialCutsCouple*,
-			 const G4DynamicParticle*,
-			 G4double,
-			 G4double);
-
   void SampleScattering(const G4DynamicParticle*,
 			G4double safety);
@@ -114,6 +108,4 @@
   G4double LatCorrelation();
 
-  void GeomLimit(const G4Track& track);
-
   inline G4double GetLambda(G4double kinEnergy);
 
@@ -129,9 +121,7 @@
   G4ParticleChangeForMSC*     fParticleChange;
 
-  G4SafetyHelper*             safetyHelper;
   G4PhysicsTable*             theLambdaTable;
   const G4MaterialCutsCouple* couple;
   G4LossTableManager*         theManager;
-
 
   G4double mass;
@@ -223,13 +213,17 @@
 {
     lnZ = std::log(Zeff);
-    coeffth1 = 0.885+lnZ*(0.104-0.0170*lnZ);
-    coeffth2 = 0.028+lnZ*(0.012-0.00125*lnZ);
-    coeffc1  = 2.134-lnZ*(0.1045-0.00602*lnZ);
-    coeffc2  = 0.001126-lnZ*(0.0001089+0.0000247*lnZ);
+    //new correction in theta0 formula
+    coeffth1 = (1.-8.7780e-2/Zeff)*(0.87+0.03*lnZ);                   
+    coeffth2 = (4.0780e-2+1.7315e-4*Zeff)*(0.87+0.03*lnZ);              
+    // tail parameters
+    G4double lnZ1 = std::log(Zeff+1.);
+    coeffc1  = 2.943-0.197*lnZ1;                  
+    coeffc2  = 0.0987-0.0143*lnZ1;                              
+    // for single scattering
     Z2 = Zeff*Zeff;
     Z23 = std::exp(2.*lnZ/3.);
     scr1     = scr1ini*Z23;
     scr2     = scr2ini*Z2*ChargeSquare;
-  //  lastMaterial = couple->GetMaterial();
+                                              
     Zold = Zeff;
 }
Index: trunk/source/processes/electromagnetic/standard/include/G4UrbanMscModel90.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4UrbanMscModel90.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4UrbanMscModel90.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4UrbanMscModel90.hh,v 1.4 2008/10/29 14:15:30 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4UrbanMscModel90.hh,v 1.5 2009/04/10 16:34:56 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -110,6 +110,4 @@
 
   G4double LatCorrelation();
-
-  void GeomLimit(const G4Track& track);
 
   inline G4double GetLambda(G4double kinEnergy);
Index: trunk/source/processes/electromagnetic/standard/include/G4WentzelVIModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4WentzelVIModel.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4WentzelVIModel.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4WentzelVIModel.hh,v 1.7 2008/08/04 08:49:09 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4WentzelVIModel.hh,v 1.17 2009/05/10 16:09:29 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -66,5 +66,4 @@
 class G4LossTableManager;
 class G4ParticleChangeForMSC;
-class G4SafetyHelper;
 class G4ParticleDefinition;
 
@@ -80,32 +79,26 @@
   virtual ~G4WentzelVIModel();
 
-  void Initialise(const G4ParticleDefinition*, const G4DataVector&);
-
-  G4double ComputeCrossSectionPerAtom(const G4ParticleDefinition*,
-				      G4double KineticEnergy,
-				      G4double AtomicNumber,
-				      G4double AtomicWeight=0., 
-				      G4double cut = DBL_MAX,
-				      G4double emax= DBL_MAX);
-
-  void SampleScattering(const G4DynamicParticle*, G4double safety);
-
-  void SampleSecondaries(std::vector<G4DynamicParticle*>*, 
-			 const G4MaterialCutsCouple*,
-			 const G4DynamicParticle*,
-			 G4double,
-			 G4double);
-
-  G4double ComputeTruePathLengthLimit(const G4Track& track,
-				      G4PhysicsTable* theLambdaTable,
-				      G4double currentMinimalStep);
-
-  G4double ComputeGeomPathLength(G4double truePathLength);
-
-  G4double ComputeTrueStepLength(G4double geomStepLength);
+  virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
+
+  virtual G4double ComputeCrossSectionPerAtom(const G4ParticleDefinition*,
+					      G4double KineticEnergy,
+					      G4double AtomicNumber,
+					      G4double AtomicWeight=0., 
+					      G4double cut = DBL_MAX,
+					      G4double emax= DBL_MAX);
+
+  virtual void SampleScattering(const G4DynamicParticle*, G4double safety);
+
+  virtual G4double ComputeTruePathLengthLimit(const G4Track& track,
+					      G4PhysicsTable* theLambdaTable,
+					      G4double currentMinimalStep);
+
+  virtual G4double ComputeGeomPathLength(G4double truePathLength);
+
+  virtual G4double ComputeTrueStepLength(G4double geomStepLength);
 
 private:
 
-  G4double ComputeTransportXSectionPerVolume();
+  G4double ComputeTransportXSectionPerAtom();
 
   G4double ComputeXSectionPerVolume();
@@ -133,5 +126,4 @@
   G4ParticleChangeForMSC*   fParticleChange;
 
-  G4SafetyHelper*           safetyHelper;
   G4PhysicsTable*           theLambdaTable;
   G4PhysicsTable*           theLambda2Table;
@@ -173,5 +165,4 @@
   // single scattering parameters
   G4double coeff;
-  G4double constn;
   G4double cosThetaMin;
   G4double cosThetaMax;
@@ -182,5 +173,4 @@
   G4double q2Limit;
   G4double alpha2;
-  G4double a0;
 
   // projectile
@@ -193,4 +183,5 @@
   G4double mom2;
   G4double invbeta2;
+  G4double kinFactor;
   G4double etag;
   G4double lowEnergyLimit;
@@ -198,7 +189,11 @@
   // target
   G4double targetZ;
+  G4double targetMass;
   G4double screenZ;
   G4double formfactA;
-  G4double FF[100];
+  G4int    iz;
+
+  static G4double ScreenRSquare[100];
+  static G4double FormFactor[100];
 
   // flags
@@ -240,6 +235,5 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-inline 
-void G4WentzelVIModel::SetupParticle(const G4ParticleDefinition* p)
+inline void G4WentzelVIModel::SetupParticle(const G4ParticleDefinition* p)
 {
   // Initialise mass and charge
@@ -251,5 +245,4 @@
     chargeSquare = q*q;
     tkin = 0.0;
-    lowEnergyLimit = keV*mass/electron_mass_c2;
   }
 }
@@ -264,5 +257,5 @@
     invbeta2 = 1.0 +  mass*mass/mom2;
     cosTetMaxNuc = cosThetaMax;
-    if(ekin <= 10.*cut && mass < MeV) {
+    if(mass < MeV && ekin <= 10.*cut) {
       cosTetMaxNuc = ekin*(cosThetaMax + 1.0)/(10.*cut) - 1.0;
     }
@@ -278,26 +271,18 @@
     etag    = e; 
     targetZ = Z;
-    G4int iz= G4int(Z);
+    iz = G4int(Z);
     if(iz > 99) iz = 99;
-    G4double x = fNistManager->GetZ13(iz);
-    screenZ = a0*x*x/mom2;
-    if(iz > 1) screenZ *=(1.13 + 3.76*invbeta2*Z*Z*chargeSquare*alpha2);
-    //    screenZ = a0*x*x*(1.13 + 3.76*Z*Z*chargeSquare*alpha2)/mom2;
-    // A.V. Butkevich et al., NIM A 488 (2002) 282
-    formfactA = FF[iz];
-    if(formfactA == 0.0) {
-      x = fNistManager->GetA27(iz); 
-      formfactA = constn*x*x;
-      FF[iz] = formfactA;
+    targetMass = fNistManager->GetAtomicMassAmu(iz)*amu_c2;
+    G4double m12  = mass*mass;
+    G4double x    = 1.0 + mass/targetMass;
+    kinFactor  = coeff*targetZ*chargeSquare*(1.0 +  m12/mom2)/mom2;
+    screenZ = ScreenRSquare[iz]/mom2;
+    if(iz > 1) {
+      screenZ *=(1.13 + 3.76*Z*Z*alpha2);
+      kinFactor /= (x*x);
     }
-    formfactA *= mom2;
+    //if(iz > 1) screenZ *=(1.13 + std::min(0.5,3.76*Z*Z*invbeta2*alpha2));
+    formfactA = FormFactor[iz]*mom2;
     cosTetMaxNuc2 = cosTetMaxNuc;
-    /*
-    G4double ee = 10.*eV*Z;
-    if(1 == iz) ee *= 2.0;
-    G4double z = std::min(cosTetMaxElec, 1.0 - std::max(ecut,ee)*amu_c2
-			  *fNistManager->GetAtomicMassAmu(iz)/mom2);
-    cosTetMaxElec2 = std::max(cosTetMaxNuc2, z);
-    */
     cosTetMaxElec2 = cosTetMaxElec;
   } 
Index: trunk/source/processes/electromagnetic/standard/include/G4eBremsstrahlung.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4eBremsstrahlung.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4eBremsstrahlung.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4eBremsstrahlung.hh,v 1.36 2007/05/23 08:47:34 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4eBremsstrahlung.hh,v 1.37 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -89,5 +89,5 @@
   virtual ~G4eBremsstrahlung();
 
-  G4bool IsApplicable(const G4ParticleDefinition& p);
+  virtual G4bool IsApplicable(const G4ParticleDefinition& p);
 
   // Print out of the class parameters
@@ -111,12 +111,4 @@
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4bool G4eBremsstrahlung::IsApplicable(const G4ParticleDefinition& p)
-{
-  return (&p == G4Electron::Electron() || &p == G4Positron::Positron());
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
 #endif
Index: trunk/source/processes/electromagnetic/standard/include/G4eBremsstrahlungModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4eBremsstrahlungModel.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4eBremsstrahlungModel.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4eBremsstrahlungModel.hh,v 1.25 2008/11/13 19:28:58 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4eBremsstrahlungModel.hh,v 1.26 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -75,6 +75,6 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
 
-  G4double MinEnergyCut(const G4ParticleDefinition*, 
-			const G4MaterialCutsCouple*);
+  virtual G4double MinEnergyCut(const G4ParticleDefinition*, 
+				const G4MaterialCutsCouple*);
 
   virtual G4double ComputeDEDXPerVolume(const G4Material*,
@@ -102,7 +102,4 @@
 
 protected:
-
-  inline G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
-				     G4double kineticEnergy);
 
   const G4Element* SelectRandomAtom(const G4MaterialCutsCouple* couple);
@@ -191,13 +188,3 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-inline 
-G4double G4eBremsstrahlungModel::MaxSecondaryEnergy(
-                                 const G4ParticleDefinition*,
-    				       G4double kineticEnergy)
-{
-  return kineticEnergy;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
 #endif
Index: trunk/source/processes/electromagnetic/standard/include/G4eBremsstrahlungRelModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4eBremsstrahlungRelModel.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4eBremsstrahlungRelModel.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4eBremsstrahlungRelModel.hh,v 1.10 2008/11/14 09:25:19 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4eBremsstrahlungRelModel.hh,v 1.11 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -71,6 +71,6 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
 
-  G4double MinEnergyCut(const G4ParticleDefinition*, 
-			const G4MaterialCutsCouple*);
+  virtual G4double MinEnergyCut(const G4ParticleDefinition*, 
+				const G4MaterialCutsCouple*);
 
   virtual G4double ComputeDEDXPerVolume(const G4Material*,
@@ -97,9 +97,4 @@
   inline G4double LPMconstant() const;
 
-protected:
-
-  inline G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
-				     G4double kineticEnergy);
-
 private:
 
@@ -207,13 +202,4 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-inline G4double 
-G4eBremsstrahlungRelModel::MaxSecondaryEnergy(const G4ParticleDefinition*,
-					      G4double kineticEnergy)
-{
-  return kineticEnergy;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
 
 inline G4double G4eBremsstrahlungRelModel::Phi1(G4double gg, G4double)
Index: trunk/source/processes/electromagnetic/standard/include/G4eCoulombScatteringModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4eCoulombScatteringModel.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4eCoulombScatteringModel.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4eCoulombScatteringModel.hh,v 1.36 2008/08/04 08:49:09 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4eCoulombScatteringModel.hh,v 1.43 2009/05/10 16:09:29 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -65,6 +65,6 @@
 #include "G4VEmModel.hh"
 #include "G4PhysicsTable.hh"
+#include "globals.hh"
 #include "G4NistManager.hh"
-#include "globals.hh"
 
 class G4ParticleChangeForGamma;
@@ -137,5 +137,4 @@
 
   G4double                  coeff;
-  G4double                  constn;
   G4double                  cosThetaMin;
   G4double                  cosThetaMax;
@@ -160,4 +159,5 @@
   G4double                  mom2;
   G4double                  invbeta2;
+  G4double                  kinFactor;
   G4double                  etag;
   G4double                  lowEnergyLimit;
@@ -165,14 +165,17 @@
   // target
   G4double                  targetZ;
+  G4double                  targetMass;
   G4double                  screenZ;
   G4double                  formfactA;
   G4int                     idxelm;
+  G4int                     iz;
 
 private:
 
-  G4double                  a0;
   G4double                  alpha2;
   G4double                  faclim;
-  G4double                  FF[100];
+
+  static G4double ScreenRSquare[100];
+  static G4double FormFactor[100];
 
   G4bool                    isInitialised;             
@@ -204,5 +207,4 @@
     chargeSquare = q*q;
     tkin = 0.0;
-    lowEnergyLimit = keV*mass/electron_mass_c2;
   }
 }
@@ -219,5 +221,5 @@
     cosTetMinNuc = cosThetaMin;
     cosTetMaxNuc = cosThetaMax;
-    if(ekin <= 10.*cut && mass < MeV && cosThetaMin < 1.0) {
+    if(mass < MeV && cosThetaMin < 1.0 && ekin <= 10.*cut) {
       cosTetMinNuc = ekin*(cosThetaMin + 1.0)/(10.*cut) - 1.0;
     }
@@ -233,29 +235,22 @@
     etag    = e; 
     targetZ = Z;
-    G4int iz= G4int(Z);
+    iz= G4int(Z);
     if(iz > 99) iz = 99;
-    G4double x = fNistManager->GetZ13(iz);
-    screenZ = a0*x*x/mom2;
-    if(iz > 1) screenZ *=(1.13 + 3.76*invbeta2*Z*Z*chargeSquare*alpha2);
-    //screenZ = a0*x*x*(1.13 + 3.76*Z*Z*chargeSquare*alpha2)/mom2;
-    // A.V. Butkevich et al., NIM A 488 (2002) 282
-    formfactA = FF[iz];
-    if(formfactA == 0.0) {
-      x = fNistManager->GetA27(iz); 
-      formfactA = constn*x*x;
-      FF[iz] = formfactA;
+    targetMass   = fNistManager->GetAtomicMassAmu(iz)*amu_c2;
+    G4double m12 = mass*mass;
+    G4double x   = 1.0 + mass/targetMass;
+    kinFactor    = (1.0 +  m12/mom2)/mom2;
+
+    screenZ = ScreenRSquare[iz]/mom2;
+    if(iz > 1) {
+      screenZ *=(1.13 + 3.76*Z*Z*alpha2);
+      kinFactor /= (x*x);
     }
-    formfactA *= mom2;
+    // if(iz > 1) screenZ *=(1.13 + std::min(0.5,3.76*Z*Z*invbeta2*alpha2));
+    formfactA = FormFactor[iz]*mom2;
     cosTetMaxNuc2 = cosTetMaxNuc;
-    if(particle == theProton && 1 == iz && cosTetMaxNuc2 < 0.0) {
+    if(1 == iz && particle == theProton && cosTetMaxNuc2 < 0.0) {
       cosTetMaxNuc2 = 0.0;
     }
-    /*
-    G4double ee = 10.*eV*Z;
-    if(1 == iz) ee *= 2.0;
-    G4double z = std::min(cosTetMaxElec, 1.0 - std::max(ecut,ee)*amu_c2
-			  *fNistManager->GetAtomicMassAmu(iz)/mom2);
-    cosTetMaxElec2 = std::max(cosTetMaxNuc2, z);
-    */
     cosTetMaxElec2 = cosTetMaxElec;
   } 
Index: trunk/source/processes/electromagnetic/standard/include/G4eIonisation.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4eIonisation.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4eIonisation.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4eIonisation.hh,v 1.35 2007/05/23 08:47:34 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4eIonisation.hh,v 1.36 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -88,5 +88,5 @@
   virtual ~G4eIonisation();
 
-  G4bool IsApplicable(const G4ParticleDefinition& p);
+  virtual G4bool IsApplicable(const G4ParticleDefinition& p);
 
   // Print out of the class parameters
@@ -98,6 +98,6 @@
 					   const G4ParticleDefinition*);
 
-  G4double MinPrimaryEnergy(const G4ParticleDefinition*,
-			    const G4Material*, G4double cut);
+  virtual G4double MinPrimaryEnergy(const G4ParticleDefinition*,
+				    const G4Material*, G4double cut);
 
 private:
@@ -114,23 +114,4 @@
 };
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4eIonisation::MinPrimaryEnergy(const G4ParticleDefinition*,
-						const G4Material*,
-						G4double cut)
-{
-  G4double x = cut;
-  if(isElectron) x += cut;
-  return x;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4bool G4eIonisation::IsApplicable(const G4ParticleDefinition& p)
-{
-  return (&p == G4Electron::Electron() || &p == G4Positron::Positron());
-}
-
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
Index: trunk/source/processes/electromagnetic/standard/include/G4eplusAnnihilation.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4eplusAnnihilation.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4eplusAnnihilation.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4eplusAnnihilation.hh,v 1.23 2007/05/23 08:47:34 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4eplusAnnihilation.hh,v 1.24 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -73,5 +73,5 @@
   virtual ~G4eplusAnnihilation();
 
-  G4bool IsApplicable(const G4ParticleDefinition& p);
+  virtual G4bool IsApplicable(const G4ParticleDefinition& p);
 
   virtual G4VParticleChange* AtRestDoIt(
@@ -79,5 +79,5 @@
                              const G4Step& stepData);
 
-  G4double AtRestGetPhysicalInteractionLength(
+  virtual G4double AtRestGetPhysicalInteractionLength(
                              const G4Track& track,
                              G4ForceCondition* condition
@@ -96,22 +96,4 @@
 };
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4bool G4eplusAnnihilation::IsApplicable(const G4ParticleDefinition& p)
-{
-  return (&p == G4Positron::Positron());
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline 
-G4double G4eplusAnnihilation::AtRestGetPhysicalInteractionLength(
-                              const G4Track&, G4ForceCondition* condition)
-{
-  *condition = NotForced;
-  return 0.0;
-}
-
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
Index: trunk/source/processes/electromagnetic/standard/include/G4hIonisation.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4hIonisation.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4hIonisation.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4hIonisation.hh,v 1.41 2008/09/14 17:11:48 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4hIonisation.hh,v 1.42 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -93,8 +93,8 @@
   virtual ~G4hIonisation();
 
-  G4bool IsApplicable(const G4ParticleDefinition& p);
+  virtual G4bool IsApplicable(const G4ParticleDefinition& p);
 
-  G4double MinPrimaryEnergy(const G4ParticleDefinition* p,
-			    const G4Material*, G4double cut);
+  virtual G4double MinPrimaryEnergy(const G4ParticleDefinition* p,
+				    const G4Material*, G4double cut);
 
   // Print out of the class parameters
@@ -123,24 +123,4 @@
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4bool G4hIonisation::IsApplicable(const G4ParticleDefinition& p)
-{
-  return (p.GetPDGCharge() != 0.0 && p.GetPDGMass() > 10.0*MeV &&
-	 !p.IsShortLived());
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4hIonisation::MinPrimaryEnergy(const G4ParticleDefinition*,
-						const G4Material*,
-						G4double cut)
-{
-  G4double x = 0.5*cut/electron_mass_c2;
-  G4double g = x*ratio + std::sqrt((1. + x)*(1. + x*ratio*ratio));
-  return mass*(g - 1.0);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
 inline void G4hIonisation::ActivateNuclearStopping(G4bool val)
